/*
 *	main.c
 *
 *	|`bƂɂ`ǂ
 *
 *	* Fri Mar 24 04:10:00 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	
 ****************************************************************************/

/* ݂ɂ̉]Ƃ́ASZɑ΂OZ̑΍W
 * - KUMI_ROT_*̏ԂƁAĂKv܂B
 */
static const char kumi_rot_tbl[4/*SIDE.kumi_rot*/][2/*col,row*/] = {
	/* EE     EEE      EEE      EEE */
	/* EE     E      EE      E */
	/* EEE     EEE      EE      EEE */
	{  0, -1 }, {  1,  0 }, {  0,  1 }, { -1,  0 },
};

/* T
 * - TACELL.root͏㏑̂ŁADx:,,,E:łB
 *   ۂ̏éAerase_test()Aerase_init()QƂĂB
 * - Tʂ𒲐邽߂ɁAT̏Ԃ͕ύXĂ\܂B
 *   ̔zёւ邾ŁAvȎ͕̕ύXsvłB
 */
static const char erase_dir_tbl[4/*dir*/][2/*col,row*/] = {
	{  0, -1 },	/*  */
	{ -1,  0 },	/*  */
	{  0,  1 },	/*  */
	{  1,  0 },	/* E */
};

/* 󂫃Z̏d݃e[u ()
 */
static const unsigned char space_weight_tbl[FIELD_ROWS][FIELD_COLS] = {
	{    0,    0,    0,    0,    0,    0,    0}, //------------------
	{    0,    0,    0,    0,    0,    0,    0}, //ʊO
	{    0,    0,    0,    0,    0,    0,    0}, //------------------
	/*----------------------------------------*/
	{10*12,12*12,14*12,16*12,14*12,12*12,10*12}, //--s̏d݂
	{10*11,12*11,14*11,16*11,14*11,12*11,10*11}, //--Ă݂܂
	{ 1*10, 2*10, 4*10,16*10, 4*10, 2*10, 1*10},
	{ 1* 9, 2* 9, 4* 9,16* 9, 4* 9, 2* 9, 1* 9},
	{ 1* 8, 2* 8, 4* 8,16* 8, 4* 8, 2* 8, 1* 8},
	{ 1* 7, 2* 7, 4* 7,16* 7, 4* 7, 2* 7, 1* 7},
	{ 2* 6, 1* 6, 4* 6,16* 6, 4* 6, 1* 6, 2* 6}, //------------------
	{ 2* 5, 1* 5, 4* 5,16* 5, 4* 5, 1* 5, 2* 5}, //tBbV{[
	{ 2* 4, 1* 4, 4* 4,16* 4, 4* 4, 1* 4, 2* 4}, //Ղ悤
	{ 2* 3, 1* 3, 4* 3,16* 3, 4* 3, 1* 3, 2* 3}, //Ȅd݂
	{ 2* 2, 1* 2, 4* 2,16* 2, 4* 2, 1* 2, 2* 2}, //ւĂ݂܂
	{ 2* 1, 1* 1, 4* 1,16* 1, 4* 1, 1* 1, 2* 1}, //------------------
};
/* Z̏d݃oCAX (d݃e[ủeAa炰ʂł) */
#define SPACE_WEIGHT_BIAS 32

/* vl[`xe[u ()
 */
static const LEVEL level_tbl[13/*i_ch*/] = {
	{            0,   0 },	/* CH01 (Player) */
	{ OUTER_ROWS+5, 3*3 },	/* CH02 */
	{ OUTER_ROWS+4, 3*4 },	/* CH03 */
	{ OUTER_ROWS+3, 3*5 },	/* CH04 */
	{ OUTER_ROWS+2, 4*3 },	/* CH05 */
	{ OUTER_ROWS+2, 4*4 },	/* CH06 */
	{ OUTER_ROWS+2, 4*5 },	/* CH07 */
	{ OUTER_ROWS+1, 5*3 },	/* CH08 */
	{ OUTER_ROWS+1, 5*4 },	/* CH09 */
	{ OUTER_ROWS+1, 5*5 },	/* CH10 */
	{ OUTER_ROWS+0, 6*3 },	/* CH11 */
	{ OUTER_ROWS+0, 6*4 },	/* CH12 */
	{ OUTER_ROWS+0, 6*5 },	/* CH13 */
};

/* Xe[W1,2̏zu (vC[̂)
 * - 1 = , 2 = , 3 = , 4 = 
 */
static const unsigned char stage_form[3/*i_ch*/][FIELD_ROWS][FIELD_COLS] = { {
	/** (Dummy) **/
},{
	/** Stage 1 **/
	{3,1,3,2,3,4,3},
	{1,1,1,2,4,4,4},
	{3,1,3,2,3,4,3},
	/*------------*/
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
},{
	/** Stage 2 **/
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	/*------------*/
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	{0,3,0,0,0,3,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
} };

/*--------------------------------------------------------------------------*/

/* wi */
static const short bg_ptn[7/*i_bg*/] = {
	SPR_BG1, SPR_BG2, SPR_BG3, SPR_BG4, SPR_BG5,SPR_BG6, SPR_BG7,
};

/* L */
static const short ch_ptn[13/*i_ch*/] = {
	SPR_CH01,
	SPR_CH02, SPR_CH03, SPR_CH04, SPR_CH05, SPR_CH06, SPR_CH07,
	SPR_CH08, SPR_CH09, SPR_CH10, SPR_CH11, SPR_CH12, SPR_CH13,
};

/* READY */
static const short ready_ptn[2/*x1,x2*/][5] = {
	{ SPR_READY11, SPR_READY12, SPR_READY13, SPR_READY14, SPR_READY15 },
	{ SPR_READY21, SPR_READY22, SPR_READY23, SPR_READY24, SPR_READY25 },
};
static const short ready_pos[5][2] = {
	{ 64 - 20 * 2, 32 },
	{ 64 - 20 * 1, 32 },
	{ 64         , 32 },
	{ 64 + 20 * 1, 32 },
	{ 64 + 20 * 2, 32 },
};

/* GO! */
static const short go_ptn[2/*x1,x2*/][3] = {
	{ SPR_GO11, SPR_GO12, SPR_GO13 },
	{ SPR_GO21, SPR_GO22, SPR_GO23 },
};
static const short go_pos[3][2] = {
	{ 64 - 20 * 1, 32 },
	{ 64         , 32 },
	{ 64 + 20 * 1, 32 },
};

typedef struct _PTN {
	short nyan[4/*color*/][3/*anim*/];	/* ɂA */
	short nyan_f;				/* ɂA() */
	short hari[4/*color*/];			/* ͂ɂ */
	short hari_f;				/* ͂ɂ() */
	short ojama[3/*anim*/];			/*  */
	short ojama_e;				/* () */
	short doku[4/*anim*/];			/* hN */
	short erase[5/*anim*/];			/* ŃGtFNg */
	short fire[10/*anim*/];			/* UGtFNg */
} PTN;

static const PTN ptn_tbl[2/*side*/] = { {
	/* nyan */
	{ { SPR_NYAN11, SPR_NYAN12, SPR_NYAN13 },
	  { SPR_NYAN21, SPR_NYAN22, SPR_NYAN23 },
	  { SPR_NYAN31, SPR_NYAN32, SPR_NYAN33 },
	  { SPR_NYAN41, SPR_NYAN42, SPR_NYAN43 } },
	/* nyan_f */
	SPR_NYANF,
	/* hari */
	{ SPR_HARI1, SPR_HARI2, SPR_HARI3, SPR_HARI4 },
	/* hari_f */
	SPR_HARIF,
	/* ojama */
	{ SPR_OJAMA11, SPR_OJAMA12, SPR_OJAMA13 },
	/* ojama_e */
	SPR_OJAMA1E,
	/* doku */
	{ SPR_DOKU11, SPR_DOKU12, SPR_DOKU13, SPR_DOKU12/*߂*/ },
	/* erase */
	{ SPR_ERASE1, SPR_ERASE2, SPR_ERASE3, SPR_ERASE4, SPR_ERASE5 },
	/* fire */
	{ SPR_FIRE01, SPR_FIRE02, SPR_FIRE03, SPR_FIRE04, SPR_FIRE05,
	  SPR_FIRE06, SPR_FIRE07, SPR_FIRE08, SPR_FIRE09, SPR_FIRE10 },
},{
	/* nyan */
	{ { SPR_WAN11 , SPR_WAN12 , SPR_WAN13  },
	  { SPR_WAN21 , SPR_WAN22 , SPR_WAN23  },
	  { SPR_WAN31 , SPR_WAN32 , SPR_WAN33  },
	  { SPR_WAN41 , SPR_WAN42 , SPR_WAN43  } },
	/* nyan_f */
	SPR_WANF,
	/* hari */
	{ SPR_HARI1, SPR_HARI2, SPR_HARI3, SPR_HARI4 },
	/* hari_f */
	SPR_HARIF,
	/* ojama */
	{ SPR_OJAMA21, SPR_OJAMA22, SPR_OJAMA23 },
	/* ojama_e */
	SPR_OJAMA2E,
	/* doku */
	{ SPR_DOKU21, SPR_DOKU22, SPR_DOKU23, SPR_DOKU22/*߂*/ },
	/* erase */
	{ SPR_ERASE1, SPR_ERASE2, SPR_ERASE3, SPR_ERASE4, SPR_ERASE5 },
	/* fire */
	{ SPR_FIRE01, SPR_FIRE02, SPR_FIRE03, SPR_FIRE04, SPR_FIRE05,
	  SPR_FIRE06, SPR_FIRE07, SPR_FIRE08, SPR_FIRE09, SPR_FIRE10 },
} };

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		app_stat = demo_main();
		if(app_stat < 0) {
			break;
		}
		joy = 0; /* gK */
		if(!setjmp(jbuf)) {
			game_main();
		}
		app_stat = 0;
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#include "texture.h"
#undef TEXTURE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#include "texture.h"
#undef TEXTURE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	ch_sel[0/*1P*/] = 0;
	ch_sel[1/*2P*/] = 1;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	/*{{f*/
	if(app_stat == APP_STAT_DEMO) {
		if(joy & (TRG_A | TRG_B | TRG_SELECT)) {
			joy = 0; /* gK */
			longjmp(jbuf, 1);
		}
		if((pceTimerGetCount() % 1000) < 500) {
			if((pceTimerGetCount() / 1000) & 1) {
				render_string_framed(&render, 41, 42, "GAME",   0x80, 0x003);
				render_string_framed(&render, 64, 42, "OVER",   0x80, 0x003);
			} else {
				render_string_framed(&render, 36, 42, "PRESS",  0x80, 0x003);
				render_string_framed(&render, 64, 42, "BUTTON", 0x80, 0x003);
			}
		}
	}
	/*}}f*/

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
#define stage_sel	(ch_sel[1])
#define MIN_STAGE	1
#define MAX_STAGE	(ARRAY_SIZE(ch_ptn) - 1)

	int result = 0;
	int bg_x = 0;
	int blind = DISP_Y / 2;
	//
	int i;
	int x;
	int y;

	i = 0;
	for(;;) {
		schedule();

		/* wiA^Cg\B */
		sprite_draw((bg_x / 4) - DISP_X, 0, SPR_BG3, DRW_NOMAL);
		sprite_draw((bg_x / 4)         , 0, SPR_BG3, DRW_NOMAL);
		bg_x = (bg_x + 1) & (DISP_X * 4 - 1);
		sprite_draw(0, 0, SPR_TITLE, DRW_NOMAL);

		/* XRA\B */
		y = 1;
		x = 1;
		render_printf_framed(&render, x, y, 0x82, 3, "1P");
		x += 10;
		render_printf_framed(&render, x, y, 0x82, 1, "%05d", p1score);
		render_printf_framed(&render, x, y, 0x82, 3, "%5d", p1score);
		x = 96;
		render_printf_framed(&render, x, y, 0x82, 3, "HI");
		x += 10;
		render_printf_framed(&render, x, y, 0x82, 1, "%05d", hiscore);
		render_printf_framed(&render, x, y, 0x82, 3, "%5d", hiscore);

		/* JnXe[W̕\B */
		x = (DISP_X - 4 * 12) / 2 - 1;
		y = 62;
		if(stage_sel == 1) {
			render_printf_framed(&render, x, y, 0x82, 3, "  STAGE %2d >", stage_sel);
		} else if(stage_sel == MAX_STAGE) {
			render_printf_framed(&render, x, y, 0x82, 3, "< STAGE %2d  ", stage_sel);
		} else {
			render_printf_framed(&render, x, y, 0x82, 3, "< STAGE %2d >", stage_sel);
		}

		/* vvg\B */
		if(now % SEC(1) < SEC(0.75)) {
			x = (DISP_X - 4 * 8) / 2 - 1;
			y = DISP_Y - 16;
			render_string_framed(&render, x, y, " A START", 0x82, 3);
			y += 8;
			render_string_framed(&render, x, y, "SEL EXIT", 0x82, 3);
		}

		/* uCh\AB */
		render_rectangle_fill(&render, 0,      0, DISP_X,  blind, 3);
		render_rectangle_fill(&render, 0, DISP_Y, DISP_X, -blind, 3);
		if(!result) {
			blind -= 8;
			if(blind < 0) {
				blind = 0;
			}
		} else {
			blind += 8;
			if(blind > DISP_Y / 2) {
				blind = DISP_Y / 2;
				break; /*  */
			}
		}

		/* I蔻B */
		if(!result) {
			if(joy & TRG_SELECT) {
				result = -1;
				break; /* uChAj[V */
			}
			if((joy & TRG_LF) && (stage_sel > MIN_STAGE)) {
				stage_sel--;
				i = 0;
			}
			if((joy & TRG_RI) && (stage_sel < MAX_STAGE)) {
				stage_sel++;
				i = 0;
			}
			if(joy & TRG_A) {
				result = APP_STAT_GAME;
				i = 0;
			}
			if((++i >= SEC(15)) || (joy & TRG_B)) {
				result = APP_STAT_DEMO;
				i = 0;
			}
		}
	}

	return result;

#undef stage_sel
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	SIDE* side;
	int i_side;
	int fire_active;

	/* Q[܂B */
	game_init();

	for(;;) {
		/* Xe[W܂B */
		stage_init();

		/* zu̗AREADYAGO!\s܂B */
		game_ready();

		for(;;) {
			schedule();

			/* [gs܂B */
			game.rate_cnt++;
			if(game.rate_cnt >= SEC(60)) {
				game.rate++;
				game.rate_cnt = 0;
				game.hurry_stat = 1;
				game.hurry_cnt = 0;
			}

			for(i_side = 0; i_side < 2; i_side++) {
				side = &game.side[i_side];

				/* ܃L[܂B */
				ojama_queue_action(side);

				/* UGtFNg𓯎is܂B */
				fire_active = fire_action(side);

				switch(side->stat) {
				case SIDE_STAT_KUMI:
					/* ݂ɂړ... */
					if(!kumi_action(side)) {
						/* ݂ɂ̉܂B */
						kumi_done(side);
						/* ֈڍs܂B
						 * - ݂̉ɂ́AڒAj[V܂݂܂B
						 */
						side->stat = SIDE_STAT_FALL;
					}
					break;
				case SIDE_STAT_FALL:
					/* tB[h... */
					if(!fall_action(side)) {
						/* ł... */
						if(erase_test(side)) {
							/* łֈڍs܂B */
							side->stat = SIDE_STAT_ERASE;
							/* łZbgAbv܂B */
							erase_init(side);
						/* łȂ... */
						} else {
							/* UGtFNg҂ֈڍs܂B */
							side->stat = SIDE_STAT_FIRE;
						}
					}
					break;
				case SIDE_STAT_ERASE:
					/* ł... */
					if(!erase_action(side)) {
						/* UAEs܂B */
						erase_done(side);
						/* ֈڍs܂B */
						side->stat = SIDE_STAT_FALL;
					}
					break;
				case SIDE_STAT_FIRE:
					/* UGtFNgĂ...
					 * - EGtFNgAtB[hł܂Aj[VpĂԂɁA
					 *   ܂~Ă̂邽߂ɁAEGtFNg̊҂܂B
					 * - tB[hւ̍UGtFNǵAisĂɖ肠܂񂪁A
					 *   EGtFNgƋʂłȂ̂ŁAAŊ҂Ƃɂ܂B
					 */
					if(!fire_active) {
						/* ܏oZbgAbv܂B */
						ojama_init(side);
						/* ܏oֈڍs܂B */
						side->stat = SIDE_STAT_OJAMA;
					}
					break;
				case SIDE_STAT_OJAMA:
					/* ܏o... */
					if(!ojama_action(side)) {
						/* ͂ɂωֈڍs܂B */
						side->stat = SIDE_STAT_HARI;
						/* ͂ɂωZbgAbv܂B */
						hari_init(side);
					}
					break;
				case SIDE_STAT_HARI:
					/* ͂ɂω... */
					if(!hari_action(side)) {
						/* s܂B */
						if(side->field[OUTER_ROWS][CENTER_COL].type) {
							/* ԂֈڍsA肪SIDE_STAT_WINɂȂ̂҂܂B */
							side->stat = SIDE_STAT_LOSE;
						} else {
							/* ݂ɂړֈڍs܂B */
							side->stat = SIDE_STAT_KUMI;
							/* ݂ɂړZbgAbv܂B */
							kumi_init(side);
						}
					}
					break;
				case SIDE_STAT_WIN:
					/* SIDE_STAT_WINɂȂ炱̃[v𔲂̂ŁA֗邱Ƃ͗L蓾܂B */
					DIE();
				case SIDE_STAT_LOSE:
					/* ɁA肪SIDE_STAT_WINɂȂ̂҂܂B */
					break;
				default:
					DIE();
				}
			}

			bg_disp(0);
			//
			info_disp(0);
			info_disp(1);
			//
			field_disp(0);
			field_disp(1);
			//
			kumi_disp(0);
			kumi_disp(1);
			//
			hurry_disp();
			//
			fire_disp(0);
			fire_disp(1);

			/* UAAłȂ΁As܂B
			 * - SIDE_STAT_LOSEԂłAs܂B
			 *   Ȃ킿A1P2PSIDE_STAT_LOSEֈڍsꍇA1Pɓ]킯łB
			 *   {dlłB
			 */
			if(game.side[1].stat == SIDE_STAT_LOSE) {		/* 2PԂŁA */
				if((game.side[0].stat != SIDE_STAT_FALL ) &&	/* 1PUAAłȂ... */
				   (game.side[0].stat != SIDE_STAT_ERASE)) {
					game.side[0].stat = SIDE_STAT_WIN;	/* 1P̏łB */
					break;					/* sAj[VֈڍsB */
				}
			}
			if(game.side[0].stat == SIDE_STAT_LOSE) {		/* 1PԂŁA */
				if((game.side[1].stat != SIDE_STAT_FALL ) &&	/* 2PUAAłȂ... */
				   (game.side[1].stat != SIDE_STAT_ERASE)) {	
					game.side[1].stat = SIDE_STAT_WIN;	/* 2P̏łB */
					break;					/* sAj[VֈڍsB */
				}
			}
		}

		/* Xe[WNẢos܂B */
		game_clear();

		/* ʏQ[łȂ΁A1Q[ŏIłB */
		if(app_stat != APP_STAT_GAME) {
			break;
		}

		/* Q[I[o[s܂B */
		if((!game.side[0].i_ch && game.side[0].stat == SIDE_STAT_LOSE) ||
		   (!game.side[1].i_ch && game.side[1].stat == SIDE_STAT_LOSE)) {
			break;
		}

		/* CPUL֐i߂܂B */
		if(game.side[0].i_ch) {
			if(game.side[0].i_ch < ARRAY_SIZE(ch_ptn) - 1) {
				game.side[0].i_ch++;
			} else {
				break; /* I[NA */
			}
		}
		if(game.side[1].i_ch) {
			if(game.side[1].i_ch < ARRAY_SIZE(ch_ptn) - 1) {
				game.side[1].i_ch++;
			} else {
				break; /* I[NA */
			}
		}
	}

	/* ʏQ[Ȃ... */
	if(app_stat == APP_STAT_GAME) {

		/* Q[I[o[\s܂B */
		game_over();

		/* 1PXRAXV܂B */
		if(!game.side[0].i_ch) {
			p1score = game.side[0].score;
		}
		if(!game.side[1].i_ch) {
			p1score = game.side[1].score;
		}

		/* nCXRAXV܂B */
		if(p1score > hiscore) {
			hiscore = p1score;
		}
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof(GAME));

	side_init(0);
	side_init(1);
}

/****************************************************************************
 *	side_init
 ****************************************************************************/

void
side_init(int i_side)
{
	SIDE* side = &game.side[i_side];

	memset(side, 0, sizeof(SIDE));

	side->i_side = i_side;
	if(app_stat == APP_STAT_DEMO) {
		static int first_demo[2/*i_side*/] = { 10/*tby*/, 11/*g{̂*/ };
		if(first_demo[side->i_side]) {
			/* N㏉f̂݁ALŒB(ĥΐJ[hƂ邽߂) */
			side->i_ch = first_demo[side->i_side];
			first_demo[side->i_side] = 0; /* 񂩂烉_ */
		} else {
			do {
				side->i_ch = RND16_RANGE(seed, 1, ARRAY_SIZE(ch_ptn));
			} while(game.side[side->i_side ^ 1].i_ch == side->i_ch); /* Lΐ̃f͕sRȂ̂ŉ */
		}
	} else {
		side->i_ch = ch_sel[i_side];
	}
	if(side->i_ch) { /* CPU */
		side->think = &game.think[i_side];
	}

	if(!i_side) {
		side->disp_field_x	=  2;
		side->disp_field_y	=  0 - CELL_H * OUTER_ROWS;
		side->disp_next_x[0]	= 54;
		side->disp_next_y[0]	= 10;
		side->disp_next_x[1]	= 54;
		side->disp_next_y[1]	= 27;
		side->disp_max_branch_x	= 55;
		side->disp_max_branch_y	= 63;
		side->disp_max_length_x	= 55;
		side->disp_max_length_y	= 79;
	} else {
		side->disp_field_x	= 76;
		side->disp_field_y	=  0 - CELL_H * OUTER_ROWS;
		side->disp_next_x[0]	= 66;
		side->disp_next_y[0]	= 10;
		side->disp_next_x[1]	= 66;
		side->disp_next_y[1]	= 27;
		side->disp_max_branch_x	= 66;
		side->disp_max_branch_y	= 63;
		side->disp_max_length_x	= 66;
		side->disp_max_length_y	= 79;
	}
}

/****************************************************************************
 *	stage_init
 ****************************************************************************/

void
stage_init()
{
	int next_seed = pceTimerGetCount();
	//
	SIDE* side;
	int i_side;
	int col;
	int row;
	CELL* cell;

	/* [gA[gpJE^Zbg܂B */
	game.rate = 0;
	game.rate_cnt = 0;

	/* HURRY UP! ԁAHURRY UP! Aj[VJE^Zbg܂B */
	game.hurry_stat = 0;
	game.hurry_cnt = 0;

	/* wi肵܂B */
	       if(!game.side[0].i_ch &&  game.side[1].i_ch) { /* vC[CPU */
		game.i_bg = (game.side[1].i_ch - 1) % ARRAY_SIZE(bg_ptn);
	} else if( game.side[0].i_ch && !game.side[1].i_ch) { /* CPU΃vC[ */
		game.i_bg = (game.side[0].i_ch - 1) % ARRAY_SIZE(bg_ptn);
	} else { /* vC[΃vC[A܂́ACPUCPU */
		game.i_bg = RND16_RANGE(seed, 0, ARRAY_SIZE(bg_ptn));
	}
	if(app_stat == APP_STAT_DEMO) {
		static int first_demo = 1/*X*/;
		if(first_demo) {
			/* N㏉f̂݁AwiŒB(ĥwiƂ邽߂) */
			game.i_bg = first_demo;
			first_demo = 0;
		}
	}

	for(i_side = 0; i_side < 2; i_side++) {
		side = &game.side[i_side];

		/* ʏ */
		//side->i_side = Œ
		//side->i_ch = Xe[WNAɐݒ
		if(side->think) { /* CPU */
			side->score = 0;
			side->max_branch = 0;
			side->max_length = 0;
		}
		//
		side->stat = SIDE_STAT_KUMI;
		side->attack = 0;
		side->branch = 0;
		side->length = 0;

		/* vl[` */
		//side->think = Œ

		/* `ʒu */
		// Œ

		/* NEXT */
		side->next_seed = next_seed;
		if(app_stat == APP_STAT_DEMO) {
			/* fȂ΁A1P2P̃V[hς܂B(ƖʔȂ̂) */
			next_seed = ~next_seed;
		}

		/* ݂ɂ */
		kumi_init(side);   /* ---------- -- X */
		kumi_init(side);   /* ----------  X */
		//kumi_init(side); /* ݂ɂ  X */  ́̕Agame_ready()ōs܂B

		/* nk */
		side->quake_stat = 0;
		side->quake_cnt = 0;
		memset(side->quake_pos, 0, sizeof side->quake_pos);

		/*  */
		side->ojama = 0;
		memset(side->ojama_num, 0, sizeof side->ojama_num);
		memset(side->ojama_queue, 0, sizeof side->ojama_queue);

		/* UGtFNg */
		memset(side->fire, 0, sizeof side->fire);

		/* tB[h */
		memset(side->field, 0, sizeof side->field);

		/* Xe[W1,2́AvC[̂݁AzuLB */
		if(!side->think) {
			if((game.side[side->i_side ^ 1].i_ch == 1) ||
			   (game.side[side->i_side ^ 1].i_ch == 2)) {
				for(row = 0; row < FIELD_ROWS; row++) {
					for(col = 0; col < FIELD_COLS; col++) {
						cell = &side->field[row][col];
						cell->color = stage_form[game.side[side->i_side ^ 1].i_ch][row][col];
						if(cell->color) {
							cell->type = CELL_TYPE_NYAN;
							cell->stat = CELL_STAT_FALL;
						}
					}
				}
			}
		}
	}
}

/****************************************************************************
 *	game_ready
 ****************************************************************************/

void
game_ready()
{
	int blind = DISP_Y / 2;
	//
	int i;
	int x;
	int y;
	int i_side;
	SIDE* side;
	int cnt1;
	int cnt2;
	fixed d;
	int r;
	int active;

	/* zu̗Jn܂B
	 * - { zu̗  READYAGO!  ݂ɂo } ̗łB
	 *   SIDE_STAT_READÝAL̂A{ zu̗  READYAGO! } 󂯎܂B
	 * - SIDE_STAT_READY̊Ԃ́AGA̓e\܂B(GẢ摜͕\܂B)
	 *   info_disp()Ă΂ȂłB(GẢ摜bg_disp()󂯎̂ŁAOKłB)
	 */
	for(i_side = 0; i_side < 2; i_side++) {
		side = &game.side[i_side];
		side->stat = SIDE_STAT_READY;
	}

	/* LoB */
	for(cnt1 = SEC(0.5); (cnt1 > 0) || (blind > 0); cnt1--) {
		schedule();
		d = fidiv(fld(cnt1), SEC(0.5));
		bg_disp(d);

		/* uCh\B */
		if(blind) {
			blind -= 8/**/;
			if(blind < 0) {
				blind = 0;
			}
			render_rectangle_fill(&render, 0,      0, DISP_X,  blind, 3);
			render_rectangle_fill(&render, 0, DISP_Y, DISP_X, -blind, 3);
		}
	}

	/* zu𗎉AREADY\܂B */
#define T1 SEC(0.6)
#define T2 SEC(0.15)
#define T3 SEC(0.1)
#define T4 SEC(0.1)
#define R  64
	for(cnt1 = T1; cnt1 > -(int)(T2 + T3 * ARRAY_SIZE(*ready_ptn)); cnt1--) {
		schedule();

		for(i_side = 0; i_side < 2; i_side++) {
			side = &game.side[i_side];
			fall_action(side);
		}

		bg_disp(0);
		//
		field_disp(0);
		field_disp(1);

		for(i = 0; i < ARRAY_SIZE(*ready_ptn); i++) {
			cnt2 = cnt1 + T3 * i;
			if(cnt2 > T1) {
				continue;
			}
			x = ready_pos[i][0];
			y = ready_pos[i][1];
			if(cnt2 >= 0) {
				d = fidiv(fimul(PI2, cnt2), T1);
				r = R * cnt2 / T1;
				x -= fist(fimul(fsin(d), r));
				y += fist(fimul(fcos(d), r));
			}
			d = fadd(fild(1), fidiv(fild(cnt2 + T4), T4));
			if(ficom(d, <=, 1)) {
				sprite_draw(x, y, ready_ptn[0][i], DRW_NOMAL);
			} else if(ficom(d, >=, 2)) {
				sprite_draw(x, y, ready_ptn[1][i], DRW_NOMAL);
			} else {
				sprite_draw2(x, y, ready_ptn[0][i], DRW_NOMAL, d, d, fild(0));
			}
		}
	}
#undef T1
#undef T2
#undef T3
#undef T4
#undef R

	/* zu𗎉AGO!\܂B */
#define T1 SEC(0.1)
#define T2 SEC(0.25)
#define T3 SEC(0.1)
#define T4 SEC(0.1)
	for(cnt1 = T1; cnt1 > -(int)(T2 + T3 * ARRAY_SIZE(*go_ptn)); cnt1--) {
		schedule();

		for(i_side = 0; i_side < 2; i_side++) {
			side = &game.side[i_side];
			fall_action(side);
		}

		bg_disp(0);
		//
		field_disp(0);
		field_disp(1);

		for(i = 0; i < ARRAY_SIZE(*go_ptn); i++) {
			cnt2 = cnt1 + T3 * i;
			x = go_pos[i][0];
			y = go_pos[i][1];
			d = fadd(fild(1), fidiv(fild(cnt2 + T4), T4));
			if(ficom(d, <=, 1)) {
				sprite_draw(x, y, go_ptn[0][i], DRW_NOMAL);
			} else if(ficom(d, >=, 2)) {
				sprite_draw(x, y, go_ptn[1][i], DRW_NOMAL);
			} else {
				sprite_draw2(x, y, go_ptn[0][i], DRW_NOMAL, d, d, fild(0));
			}
		}
	}
#undef T1
#undef T2
#undef T3
#undef T4

	/* mɁAzu̗҂܂B(ɊĂƂ͎v܂AÔ) */
	do {
		schedule();

		active = 0;
		for(i_side = 0; i_side < 2; i_side++) {
			side = &game.side[i_side];
			if(fall_action(side)) {
				active = 1; /* p */
			}
		}

		bg_disp(0);
		//
		field_disp(0);
		field_disp(1);

	} while(active);

	for(i_side = 0; i_side < 2; i_side++) {
		side = &game.side[i_side];
		/* ݂ɂړֈڍs܂B */
		side->stat = SIDE_STAT_KUMI;
		/* ݂ɂړZbgAbv܂B */
		kumi_init(side);
	}
}

/****************************************************************************
 *	game_clear
 ****************************************************************************/

void
game_clear()
{
	int blind = 0;
	//
	int i;
	int x;
	int y;
	int i_side;
	SIDE* side;
	int cnt;
	fixed d;
	fixed s;
	fixed r;
	int sprno;

	/* ܂AWINo\s܂B */
#define T1 SEC(0.5)
	for(i = -T1; i < 0; i++) {
		schedule();

		bg_disp(0);
		//
		info_disp(0);
		info_disp(1);
		//
		field_disp(0);
		field_disp(1);

		for(i_side = 0; i_side < 2; i_side++) {
			side = &game.side[i_side];
			if(side->stat != SIDE_STAT_WIN) {
				continue;
			}

			x = side->disp_field_x + CELL_W * FIELD_COLS / 2;
			y = 40/**/;
			//
			cnt = i;
			sprno = SPR_WIN;
			//
			r = fidiv(fimul(PI2, cnt % T1), T1);
			//
			d = fidiv(fimul(PI_2, cnt), T1);	/* -/2 -> 0 */
			d = fcos(d);				/*     0 -> 1 () */
			s = fsub(fild(2), d);			/*     2 -> 1 () */
			//
			sprite_draw2(x, y, sprno, DRW_NOMAL, s, s, r);
		}
	}
#undef T1

	/* Xe[WNAnkJn܂B */
	for(i_side = 0; i_side < 2; i_side++) {
		side = &game.side[i_side];
		side->quake_stat = QUAKE_STAT_CLEAR;
		side->quake_cnt = 0;
	}

	/* nkisAWINALOSE\܂B */
#define T1 SEC(5)
#define T2 SEC(0.9)
#define T3 SEC(1.3)
	i = 0;
	do {
		schedule();

		if(!blind) {
			if((i == SEC(5.0/**/)) ||
			  ((i >= SEC(0.5/**/)) && (joy & (TRG_A | TRG_B | TRG_SELECT)))) { /* LZ */
				blind += 8/**/;
			}
		}

		bg_disp(0);
		//
		info_disp(0);
		info_disp(1);
		//
		field_disp(0);
		field_disp(1);

		/* WINALOSE\B */
		for(i_side = 0; i_side < 2; i_side++) {
			side = &game.side[i_side];

			x = side->disp_field_x + CELL_W * FIELD_COLS / 2;
			y = 40/**/;
			//
			cnt = i;
			if(side->stat == SIDE_STAT_WIN) {
				sprno = SPR_WIN;
			} else {
				sprno = SPR_LOSE;
				cnt += SEC(0.5); /* 炷 */
			}
			//
			d = fidiv(fimul(PI2, cnt % T2), T2);
			s = fiadd(fmul(fsin(d), fld(0.05/**/)), 1);
			//
			d = fidiv(fimul(PI2, cnt % T3), T3);
			r = fmul(fsin(d), fidiv(PI2, 64/**/));
			//
			sprite_draw2(x, y, sprno, DRW_NOMAL, s, s, r);
		}

		/* uCh\B */
		if(blind) {
			blind += 8/**/;
			if(blind > DISP_Y / 2) {
				blind = DISP_Y / 2;
			}
			render_rectangle_fill(&render, 0,      0, DISP_X,  blind, 3);
			render_rectangle_fill(&render, 0, DISP_Y, DISP_X, -blind, 3);
		}

		i++;
	} while(blind < DISP_Y / 2);
	schedule();
#undef T1
#undef T2
#undef T3
}

/****************************************************************************
 *	game_over
 ****************************************************************************/

void
game_over()
{
#define X0 10
#define X1 14
#define Y0 35

	static const char str[] = "GAMEOVER";
	static const short color[] = { 0x210, 0x321, 0x332 };
	static const short pos[31] = {
		-16,-12, -8, -4,			/* [ 0.. 3] */
		  0,  4,  8, 12, 16, 20, 24, 28, 32,	/* [ 4..12] */
		 36, 40, 44, 48, 52, 56, 59, 61, 62,	/* [13..21] */
		 62, 61, 59, 56, 52, 48, 44, 40, 36,	/* [22..30] */
	};

	int i;
	int j;
	int k;
	int x;
	int y;
	int cnt;

	for(i = 0; i < SEC(7); i++) {
		schedule();
		surface_clear(&surface, 3);

		if((i >= SEC(0.5/**/)) && (joy & (TRG_A | TRG_B | TRG_SELECT))) { /* LZ */
			break;
		}

		for(k = 2; k >= 0; k--) {
			for(j = 0; j < 8; j++) {
				cnt = i - j * 5 - k * 2;
				if(cnt < 0) {
					continue;
				}
				if(j < 7) {
					if(cnt > 13) {
						cnt = 13;
					}
				} else {
					if(cnt > 30) {
						cnt = 30;
					}
				}
				x = X0 + X1 * j;
				y = pos[cnt];
				render_font_framed(&render, x, y, str[j], 0x81, color[k]);
			}
		}
	}
#undef X0
#undef X1
#undef Y0
#undef Y1 
}

/****************************************************************************
 *	score_add
 ****************************************************************************/

void
score_add(SIDE* side, int pts)
{
	side->score += pts;
	if(side->score > 99999) {
		side->score = 99999;
	}
}

/****************************************************************************
 *	bg_disp
 ****************************************************************************/

static void
bg_mask(int xx, int yy, int ww, int hh)
{
	int x;
	int y;
	int w;
	int h;
	int c;

	for(y = yy, h = hh; h; y++, h--) {
		for(x = xx, w = ww; w; x++, w--) {
			if((x ^ y) & 1) {
				c = surface_point(&surface, x, y);
				c = c == 2 ? 3 : 2;
				render_point(&render, x, y, c);
			}
		}
	}
}

void
bg_disp(fixed anim/*1.00.0*/)
{
	static unsigned char save_vbuff[DISP_X * DISP_Y];
	static int save_i_bg = -1;
	static int save_i_ch[2] = { -1, -1 };
	static int save_pos = -1;
	static int save_mask = -1;

	SIDE* side;
	int i_side;
	int x;
	int y;
	int pos;
	int mask;

	/* L̈ʒuƁAԊ|̗L肵܂B */
	if(ficom(anim, >, 0)) {
		anim = fmul(anim, anim);	/*      1.00.0 () */
		anim = fimul(anim, DISP_X / 2);	/* DISP_X/20.0 () */
		anim = fadd(anim, fld(0.5));
		pos = fist(anim);
		mask = 0;
	} else {
		pos = 0;
		mask = 1;
	}

	/* wiALAʒuAԊ|ɕω΁AO̕`挋ʂėp܂B */
	if(save_i_bg    == game.i_bg &&
	   save_i_ch[0] == game.side[0].i_ch &&
	   save_i_ch[1] == game.side[1].i_ch &&
	   save_pos     == pos &&
	   save_mask    == mask) {
		memcpy(vbuff, save_vbuff, DISP_X * DISP_Y);
		return; /* ܂ */
	}

	/* wiALAԊ|AGA`܂B */
	sprite_draw(0, 0, bg_ptn[game.i_bg], DRW_NOMAL);
	for(i_side = 0; i_side < 2; i_side++) {
		side = &game.side[i_side];

		if(!i_side) { /* 1P */
			x = side->disp_field_x - pos;
		} else {      /* 2P */
			x = side->disp_field_x + pos;
		}
		y = side->disp_field_y + CELL_H * OUTER_ROWS;
		sprite_draw(x, y, ch_ptn[side->i_ch], DRW_NOMAL);

		if(mask) {
			bg_mask(x, y,
				CELL_W *  FIELD_COLS               + 1/*Z̏dȂ蕪*/,
				CELL_H * (FIELD_ROWS - OUTER_ROWS) + 1/*Z̏dȂ蕪*/);
		}
	}
	if(mask) {
		sprite_draw(INFO_X, INFO_Y, SPR_INFO, DRW_NOMAL);
	}

	/* ̂߂ɁAwiALAԊ|A`挋ʂۑ܂B */
	save_i_bg    = game.i_bg;
	save_i_ch[0] = game.side[0].i_ch;
	save_i_ch[1] = game.side[1].i_ch;
	save_pos     = pos;
	save_mask    = mask;
	memcpy(save_vbuff, vbuff, DISP_X * DISP_Y);
}

/****************************************************************************
 *	info_disp
 ****************************************************************************/

void
info_disp(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int i;
	int x;
	int y;
	CELL cell;
	char buf[32]; /* ꂮ炢ŏ[ */

	/* NEXT */
	memset(&cell, 0, sizeof(CELL));
	cell.type = CELL_TYPE_NYAN;
	for(i = 0; i < 2; i++) { /* ,X */
		x = side->disp_next_x[i];
		y = side->disp_next_y[i];
		/* 1sNZ̏dȂ肪̂ŁAOȀɕ`܂B */
		cell.color = side->next[i][1/*Oɕ\*/];
		cell_disp(i_side, &cell, x, y);
		cell.color = side->next[i][0/*ɕ\*/];
		cell_disp(i_side, &cell, x, y + CELL_H);
	}

	if(!i_side) { /* 1P */
		/* XRA */
		sprintf(buf, "%5d", side->score); /* score_add()ɂĐ؂lߍς */
		x = SCORE_X;
		y = SCORE_Y;
		render_string(&render, x + 1, y + 1, buf, 0x82, 3);
		render_string(&render, x + 0, y + 0, buf, 0x82, 0);
	}

	/* ő啪 */
	sprintf(buf, "%2d", side->max_branch <= 99 ? side->max_branch : 99);
	x = side->disp_max_branch_x;
	y = side->disp_max_branch_y;
	render_string(&render, x, y, buf, 0x82, 0);

	/* ő咷 */
	sprintf(buf, "%2d", side->max_length <= 99 ? side->max_length : 99);
	x = side->disp_max_length_x;
	y = side->disp_max_length_y;
	render_string(&render, x, y, buf, 0x82, 0);
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static void
field_quake(SIDE* side)
{
	int col;
	int pos;
	int spd;
	int cnt;
	fixed d;

	switch(side->quake_stat) {
	case 0:
		if(!side->quake_cnt) { /*  */
			memset(side->quake_pos, 0, sizeof side->quake_pos);
			side->quake_cnt++;
		} else {
			/** no job **/
		}
		break;
	case QUAKE_STAT_ERASE:
		/* ɂŎɁA{,,j[g}A2JԂ܂B
		 * {3JԂłAP/ECE͏x̂ŁA2ɂ܂B
		 */
		if(side->quake_cnt < 3/*p^[*/ * 2/*JԂ*/) {
			static const char tbl[3/*p^[*/] = { 1,-1,0 };
			pos = tbl[side->quake_cnt % 3/*p^[*/];
			for(col = 0; col < FIELD_COLS; col++) {
				side->quake_pos[col] = pos;
			}
			side->quake_cnt++;
		} else {
			side->quake_stat = 0;
			side->quake_cnt = 0;
		}
		break;
	case QUAKE_STAT_OJAMA:
#define T SEC(1.0) /*  */
#define R 4        /*  */
		if(side->quake_cnt < T) {
			static const char delay[FIELD_COLS] = { SEC(0.3),SEC(0.0),SEC(0.1),SEC(0.2),SEC(0.1),SEC(0.0),SEC(0.3) };
			for(col = 0; col < FIELD_COLS; col++) {
				cnt = side->quake_cnt - delay[col];
				if(cnt > 0) {
					d = fidiv(fimul(PI2, cnt), (T / 2));
					d = fimul(fsin(d), R * (T - side->quake_cnt) / T);
					d = fadd(d, fld(0.5)); /* ľܓ */
					pos = fist(d);
				} else {
					pos = 0;
				}
				side->quake_pos[col] = pos;
			}
			side->quake_cnt++;
		} else {
			side->quake_stat = 0;
			side->quake_cnt = 0;
		}
		break;
#undef T
#undef R
	case QUAKE_STAT_CLEAR:
		if(side->quake_cnt < SEC(5/*tB[hŜʊOɏ[Ȏ*/)) {
			for(col = 0; col < FIELD_COLS; col++) {
				if(!side->i_side) { /* 1P */
					cnt = side->quake_cnt - SEC(0.1)/*񂠂̃fBC*/ * (FIELD_COLS - 1 - col);
				} else {            /* 2P */
					cnt = side->quake_cnt - SEC(0.1)/*񂠂̃fBC*/ * (                 col);
				}
				if(cnt <= 0) {
					side->quake_pos[col] = 0;
				} else {
					spd = 3/*x*/ - 1/*d͉x*/ * cnt;
					if(spd > CELL_H/*ő呬x*/) {
						cnt = CELL_H;
					}
					side->quake_pos[col] -= spd;
				}
			}
			side->quake_cnt++;
		} else {
			/* tB[hŜʊOɏ܂܂̏Ԃێ܂B
			 * ̃Xe[W̏ɂāAʏԂ֖߂܂B
			 */
		}
		break;
	default:
		DIE();
	}
}

void
field_disp(int i_side)
{
	SIDE* side = &game.side[i_side];
	const PTN* ptn = &ptn_tbl[i_side];
	//
	int x;
	int y;
	int col;
	int row;
	int sprno;
	CELL* cell;

	/* nkItZbgvZ܂B */
	field_quake(side);

	/* hN`܂B */
	x = side->disp_field_x + CELL_W * CENTER_COL;
	y = side->disp_field_y + CELL_H * OUTER_ROWS;
	sprno = ptn->doku[now / 2 & 3];
	sprite_draw(x, y, sprno, DRW_NOMAL);

	/* 1sNZ̏dȂ肪̂ŁAA㑤̏ɕ`܂B */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->type) {
				continue;
			}

			if(cell->type) {
				x = side->disp_field_x + CELL_W * col;
				y = side->disp_field_y + CELL_H * row + side->quake_pos[col];
				cell_disp(i_side, cell, x, y);
			}
		}
	}
}

/****************************************************************************
 *	kumi_disp
 ****************************************************************************/

void
kumi_disp(int i_side)
{
	SIDE* side = &game.side[i_side];
	const PTN* ptn = &ptn_tbl[i_side];
	//
	int i;
	int x;
	int y;
	int col;
	int row;
	int pos;
	int sprno;
	CELL cell;

	/* ݂ɂړłȂ΁A\܂B */
	if(side->stat != SIDE_STAT_KUMI) {
		return;
	}

	/* ʒuƂ݂ɂ\p̃ZAĂ܂B */
	memset(&cell, 0, sizeof(CELL));
	cell.type = side->kumi_hari ? CELL_TYPE_HARI : CELL_TYPE_NYAN;

	/* ʒu`܂B
	 * - 1sNZ̏dȂ肪̂ŁAA㑤̏ɕ`܂B
	 */
	if(now & 1) {
		switch(side->kumi_rot) {
		case KUMI_ROT_UP: /* Ȍɗ */
			col = side->kumi_col;
			for(row = FIELD_ROWS - 1; row >= 0; row--) {
				if(!side->field[row][col].type) {
					break;
				}
			}
			x = side->disp_field_x + CELL_W * col;
			y = side->disp_field_y + CELL_H * row;
			cell.color = side->kumi[0/**/];
			cell_disp(i_side, &cell, x, y);
			cell.color = side->kumi[1/*O*/];
			cell_disp(i_side, &cell, x, y - CELL_H);
			break;
		case KUMI_ROT_DN: /* Ȍɗ */
			col = side->kumi_col;
			for(row = FIELD_ROWS - 1; row >= 0; row--) {
				if(!side->field[row][col].type) {
					break;
				}
			}
			x = side->disp_field_x + CELL_W * col;
			y = side->disp_field_y + CELL_H * row;
			cell.color = side->kumi[1/*O*/];
			cell_disp(i_side, &cell, x, y);
			cell.color = side->kumi[0/**/];
			cell_disp(i_side, &cell, x, y - CELL_H);
			break;
		case KUMI_ROT_LF: /* ƊO͖֌W */
		case KUMI_ROT_RI: /* ƊO͖֌W */
			for(i = 0; i < 2; i++) {
				col = side->kumi_col;
				if(i/*O*/) {
					col += kumi_rot_tbl[side->kumi_rot][0];
				}
				for(row = FIELD_ROWS - 1; row >= 0; row--) {
					if(!side->field[row][col].type) {
						break;
					}
				}
				x = side->disp_field_x + CELL_W * col;
				y = side->disp_field_y + CELL_H * row;
				cell.color = side->kumi[i];
				cell_disp(i_side, &cell, x, y);
			}
			break;
		default:
			DIE();
		}
	}

	/* ݂ɂ`܂B
	 * - 1sNZ̏dȂ肪̂ŁAOȀɕ`܂B
	 */
	pos = fist((fixed)((int)side->kumi_pos + FRACT_MASK)); /* ؂グ */
	for(i = 1; i >= 0; i--) { /* O, */
		col = side->kumi_col;
		row = side->kumi_row;
		if(i/*O*/) {
			col += kumi_rot_tbl[side->kumi_rot][0];
			row += kumi_rot_tbl[side->kumi_rot][1];
		}
		x = side->disp_field_x + CELL_W * col;
		y = side->disp_field_y + CELL_H * row - pos;
		cell.color = side->kumi[i];
		cell_disp(i_side, &cell, x, y);

		/* Ȃ΁AŘg`܂B */
		if(!i/**/ && !(now & 3)) {
			sprno = side->kumi_hari ? ptn->hari_f : ptn->nyan_f;
			sprite_draw(x, y, sprno, DRW_NOMAL);
		}
	}
}

/****************************************************************************
 *	cell_disp
 ****************************************************************************/

void
cell_disp(int i_side, CELL* cell, int x, int y)
{
	const PTN* ptn = &ptn_tbl[i_side];
	//
	int cnt;
	int sprno;

	switch(cell->type) {
	case CELL_TYPE_NYAN:
		switch(cell->stat) {
		case 0:
			sprno = ptn->nyan[cell->color - 1][0];
			break;
		case CELL_STAT_FALL:
			cnt = cell->cnt / 2;
			cnt %= 3;
			sprno = ptn->nyan[cell->color - 1][cnt];	/* ڒ */
			break;
		case CELL_STAT_ERASE:
			cnt = cell->cnt / 2;
			if(cnt < 0) {
				sprno = ptn->nyan[cell->color - 1][0];	/* őO */
			} else if(cnt < 5) {
				sprno = ptn->erase[cnt];		/* Œ */
			} else {
				sprno = -1;				/* Ō */
			}
			break;
		default:
			DIE();
		}
		break;

	case CELL_TYPE_HARI:
		switch(cell->stat) {
		case 0:
			sprno = ptn->hari[cell->color - 1];
			break;
		case CELL_STAT_FALL:
			sprno = ptn->hari[cell->color - 1];
			break;
		case CELL_STAT_ERASE:
			cnt = cell->cnt / 2;
			if(cnt < 0) {
				sprno = ptn->hari[cell->color - 1];	/* őO */
			} else if(cnt < 5) {
				sprno = ptn->erase[cnt];		/* Œ */
			} else {
				sprno = -1;				/* Ō */
			}
			break;
		default:
			DIE();
		}
		break;

	case CELL_TYPE_OJAMA:
		switch(cell->stat) {
		case 0:
			sprno = ptn->ojama[0];
			break;
		case CELL_STAT_FALL:
			cnt = cell->cnt / 2;
			cnt %= 3;
			sprno = ptn->ojama[cnt];			/* ڒ */
			break;
		case CELL_STAT_ERASE:
			cnt = cell->cnt / 2;
			if(cnt < 0) {
				sprno = ptn->ojama[0];			/* őO */
			} else if(cnt < 5) {
				if(now & 1) {
					sprno = ptn->ojama_e;		/* Œ */
				} else {
					sprno = -1;
				}
			} else {
				sprno = -1;				/* Ō */
			}
			break;
		default:
			DIE();
		}
		break;

	default:
		DIE();
	}

	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}
}

/****************************************************************************
 *	hurry_disp
 ****************************************************************************/

/* \ƁAAj[Vis˂Ă܂B */
void
hurry_disp()
{
#define T0 SEC(2.0)
#define T1 SEC(0.5)
#define T2 SEC(1.0)

	int pos;
	int cnt1;
	int cnt2;
	fixed d;
	fixed r;

	if(!game.hurry_stat) {
		return; /* o */
	}

	cnt1 = game.hurry_cnt;
	cnt2 = cnt1 % T2;

	switch(game.hurry_stat) {
	case 1:	/* cnt1 = 0 -> T1 */
		if(++game.hurry_cnt >= T1) {
			game.hurry_stat = 2;
			game.hurry_cnt = 0;
		}
		break;
	case 2:	/* cnt1 = T1 */
		cnt1 = T1;
		if(++game.hurry_cnt >= T0) {
			game.hurry_stat = 3;
			game.hurry_cnt = 0;
		}
		break;
	case 3:	/* cnt1 = T1 -> 0 */
		cnt1 = T1 - cnt1;
		if(++game.hurry_cnt >= T1) {
			game.hurry_stat = 0; /* 薢oɖ߂ */
			game.hurry_cnt = 0;
		}
		break;
	}

	d = fidiv(fld(cnt1), T1);	/* o           0.0 ->     1.0        */
	d = fmul(d, PI_2);		/* o           0.0 ->    /2        */
	d = fsin(d);			/* o           0.0 ->     1.0 () */
	d = fisub(d, 1);		/* o          -1.0 ->     0.0 () */
	d = fimul(d, (HURRY_Y + 16));	/* o -(HURRY_Y+16) ->     0.0 () */
	d = fiadd(d,  HURRY_Y      );	/* o         -16.0 -> HURRY_Y () */
	d = fadd(d, fld(0.5));		/* ľܓ */
	pos = fist(d);

	d = fidiv(fimul(PI2, cnt2 % T2), T2);
	r = fmul(fsin(d), fidiv(PI2, 64/**/));

	sprite_draw2(HURRY_X, pos, SPR_HURRY, DRW_NOMAL, fild(1), fild(1), r);

#undef T0
#undef T1
#undef T2
}

/****************************************************************************
 *	kumi_init
 ****************************************************************************/

void
kumi_init(SIDE* side)
{
	int i;

	/* ݂ɂNEXT()NEXT(X) */
	for(i = 0; i < 2; i++) {
		side->kumi   [i] = side->next[0][i];
		side->next[0][i] = side->next[1][i];
		side->next[1][i] = RND16_RANGE(side->next_seed, 1, 5);
	}

	/* ݂ɂ̎ށA]Aʒu܂B */
	side->kumi_hari = 0;
	side->kumi_cnt = 0;
	side->kumi_col = CENTER_COL;
	side->kumi_row = OUTER_ROWS;
	side->kumi_rot = KUMI_ROT_UP;
	side->kumi_pos = fild(CELL_H);

	/* vl[`܂B */
	if(side->think) { /* CPU */
		think_init(side->think, side);
	}
}

/****************************************************************************
 *	kumi_action
 ****************************************************************************/

static int
kumi_action_player()
{
	return joy;
}

static int
kumi_action_cpu(SIDE* side)
{
	const LEVEL* level = &level_tbl[side->i_ch];
	THINK* think = side->think;
	int joy = 0;
	//
	int i;

	for(i = 0; i < 8/**/; i++) {
		think_next(think);
	}

	if(think->done) {
		if(side->kumi_hari != think->hari) {
			joy |= TRG_UP;
		}
		if(side->kumi_col < think->col) {
			joy |= TRG_RI;
		}
		if(side->kumi_col > think->col) {
			joy |= TRG_LF;
		}
		if(side->kumi_rot != think->rot) {
			joy |= TRG_A;
		}
		if(!joy) {
			if(side->kumi_row >= level->spdup_row) {
				joy |= PAD_DN;
			}
		} else {
			if(!(now % 2/*v*/)) {
				joy = 0;
			}
		}
	}

	return joy;
}

int
kumi_action(SIDE* side)
{
	int active = 0;
	//
	int joy;
	int col2;
	int row2;
	int rot2;

	/* pɂɎgAo܂B */
	int cnt = side->kumi_cnt;
	int col = side->kumi_col;
	int row = side->kumi_row;
	int rot = side->kumi_rot;
	fixed pos = side->kumi_pos;

	/* ͂擾A܂́Avl[`s܂B */
	if(side->think) { /* CPU */
		joy = kumi_action_cpu(side);
	} else { /* Player */
		joy = kumi_action_player();
	}

	/* ڒnAڒ҂ */
	if(!pos && !kumi_test(side, col, row + 1, rot)) {
		cnt++;
		if((cnt >= LAND_DELAY) || (joy & PAD_DN/*ڒ*/)) {
			goto L_EXIT; /*  */
		}

	/* AĊJ */
	} else {
		cnt = 0;
		if(joy & PAD_DN/**/) {
			pos = 0;
			/* ɂAXRAZ܂B
			 * - {10_ÂZ܂AP/ECE͌̓s1_Ƃ܂B
			 */
			score_add(side, 1);
		} else {
			pos = fsub(pos, FALL_SPEED);
		}
		while(ficom(pos, <=, 0)) {
			if(!kumi_test(side, col, row + 1, rot)) {
				pos = 0;
				if(joy & PAD_DN/**/) {
					/* ́AڒnuԂɐڒ܂B
					 * ȂƁAڒAj[V̑Oɗ]vȒʏ\1t[āAhȂ܂B
					 */
					goto L_EXIT; /*  */
				}
				break;
			}
			row++;
			pos = fiadd(pos, CELL_H);
		}
	}

	/* Eړ */
	col2 = col;
	if(joy & TRG_LF) {
		col2--;
	}
	if(joy & TRG_RI) {
		col2++;
	}
	if(col2 != col) {
		if(kumi_test(side, col2, row, rot)) {
			col = col2;
		}
	}

	/* ] */
	rot2 = rot;
	if(joy & TRG_A) {
		rot2 = (rot2 + 1) & 3;
	}
	if(joy & TRG_B) {
		rot2 = (rot2 - 1) & 3;
	}
	if(rot2 != rot) {
		if(kumi_test(side, col, row, rot2)) {
			rot = rot2;
		} else {
			col2 = col - kumi_rot_tbl[rot2][0];
			row2 = row - kumi_rot_tbl[rot2][1];
			if(kumi_test(side, col2, row2, rot2)) {
				col = col2;
				row = row2;
				rot = rot2;
			} else {
				int tmp = side->kumi[0];
				          side->kumi[0] = side->kumi[1];
				                          side->kumi[1] = tmp;
			}
		}
	}

	/* ݂ɂ̂͂ɂ */
	if(joy & (TRG_UP | TRG_SELECT)) {
		side->kumi_hari = !side->kumi_hari;
	}

	active = 1; /* p */

L_EXIT:
	/* oA߂܂B */
	side->kumi_cnt = cnt;
	side->kumi_col = col;
	side->kumi_row = row;
	side->kumi_rot = rot;
	side->kumi_pos = pos;

	return active;
}

/****************************************************************************
 *	kumi_test
 ****************************************************************************/

int
kumi_test(SIDE* side, int col, int row, int rot)
{
	int i;

	for(i = 0; i < 2; i++) {
		if((col < 0) || (col > FIELD_COLS - 1) ||
		   (row < 0) || (row > FIELD_ROWS - 1) ||
		   side->field[row][col].type) {
			return 0; /* ړs */
		}

		/* OB(ڂ̓_~[) */
		col += kumi_rot_tbl[rot][0];
		row += kumi_rot_tbl[rot][1];
	}

	return 1; /* ړ\ */
}

/****************************************************************************
 *	kumi_done
 ****************************************************************************/

void
kumi_done(SIDE* side)
{
	int i;
	int col;
	int row;
	CELL* cell;

	for(i = 0; i < 2; i++) {
		col = side->kumi_col;
		row = side->kumi_row;
		if(i/*O*/) {
			col += kumi_rot_tbl[side->kumi_rot][0];
			row += kumi_rot_tbl[side->kumi_rot][1];
		}

		cell = &side->field[row][col];
		memset(cell, 0, sizeof(CELL));
		cell->type = side->kumi_hari ? CELL_TYPE_HARI : CELL_TYPE_NYAN;
		cell->color = side->kumi[i];

		/* ƓAj[Vs߂ɁAԂŎ̉܂B */
		cell->stat = CELL_STAT_FALL;
		cell->cnt = 0;
	}
}

/****************************************************************************
 *	fall_action
 ****************************************************************************/

int
fall_action(SIDE* side)
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;
	int limit;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell1 = &side->field[row][col];
			if(!cell1->type) {
				continue;
			}

			/* ɋ󂫃ZL... */
			if((row < FIELD_ROWS - 1) &&
			  !(cell2 = cell1 + FIELD_COLS)->type) {

				/* JnA܂́Ap܂B */
				memcpy(cell2, cell1, sizeof(CELL));
				memset(cell1,     0, sizeof(CELL));
				cell2->stat = CELL_STAT_FALL;
				cell2->cnt = 0;
				active = 1; /* p */

			/* ɋ󂫃Z... */
			} else {

				/* AڒȂ΁Aڒs܂B */
				if(cell1->stat == CELL_STAT_FALL) {
					if(cell1->type == CELL_TYPE_HARI) {
						/* ͂ɂ͐ڒAj[VȂ̂ŁAZ߁B */
						limit = SEC(0.2);
					} else {
						limit = 2/*t[*/ * 3/*p^[*/ * 2/*JԂ*/ - 1;
					}
					if(cell1->cnt < limit) {
						cell1->cnt++;
						active = 1; /* p */
					} else {
						cell1->stat = 0;
					}
				}
			}
		}
	}

	return active;
}

/****************************************************************************
 *	erase_test
 ****************************************************************************/

int
erase_test(SIDE* side)
{
	int active;
	int depth;
	int col1;
	int row1;
	CELL* cell1;
	int col2;
	int row2;
	CELL* cell2;
	int dir;

	/* T[x0n߂āAVȘAȂ肪Ȃ܂ŁAT[x1Â₵܂B */
	depth = 0;
	for(;;) {
		/* ݂̒T[xł́AVȘAȂT܂B */
		active = 0; /* VȘAȂ𔭌Aactive=1 */
		for(row1 = 0; row1 <= FIELD_ROWS - 1; row1++) {
			for(col1 = 0; col1 <= FIELD_COLS - 1; col1++) {
				cell1 = &side->field[row1][col1];
				if(!cell1->color/*ɂor͂ɂȊO*/ || cell1->root/*Tς*/) {
					continue;
				}
				for(dir = 0; dir < 4; dir++) {
					col2 = col1 + erase_dir_tbl[dir][0];
					row2 = row1 + erase_dir_tbl[dir][1];
					if((col2 < 0) || (col2 > FIELD_COLS - 1) ||
					   (row2 < 0) || (row2 > FIELD_ROWS - 1)) {
						continue;
					}
					cell2 = &side->field[row2][col2];
					if((cell2->color == cell1->color) && /* F */
					   (cell2->depth == depth)) {        /* [xv */
						if(!depth) {
							if(cell2->type != CELL_TYPE_HARI) {
								continue; /* T[x0ŗאډ\ȑ́A͂ɂ̂ */
							}
							/* : CELL_ROOT(col2, row2)ł͂܂!! */
							cell2->root = CELL_ROOT(col1, row1); /* ㏑ */
						}
						cell1->root = cell2->root; /* ㏑ */
						if(cell1->type != CELL_TYPE_HARI) { /* ͂ɂ񓯎m̗אڂ͐[x0ێ */
							cell1->depth = depth + 1;
							cell2->inner = 1; /* אڂ͒[_łȂȂ */
						}
						active = 1; /* VȘAȂ𔭌 */
					}
				}
			}
		}

		/* VȘAȂ肪ȂAT܂B */
		if(!active) {
			break;
		}

		/* T[x𑝂₵āATp܂B */
		depth++;
	}

	/* T[x1ȏȂ΁AŏKvł邱Ƃ\A1ȏ̒lԂ܂B
	 * T[x0    Ȃ΁Aŏsvł邱Ƃ\A0        Ԃ܂B
	 */
	return depth;
}

/****************************************************************************
 *	erase_init
 ****************************************************************************/

void
erase_init(SIDE* side)
{
	int attack = 0;
	//
	int col1;
	int row1;
	CELL* cell1;
	int col2;
	int row2;
	CELL* cell2;
	int dir;
	int root;
	int type;

	/*{{273oCgłBX^bNɒӂĂ*/
	unsigned char root_length[FIELD_COLS * FIELD_ROWS];
	unsigned char root_branch[FIELD_COLS * FIELD_ROWS];
	unsigned char root_attack[FIELD_COLS * FIELD_ROWS];
	memset(root_length, 0, sizeof root_length);
	memset(root_branch, 0, sizeof root_branch);
	memset(root_attack, 0, sizeof root_attack);
	/*}}273oCgłBX^bNɒӂĂ*/

	/* T_Ƃ́AAAbU͂߂܂B */
	for(row1 = 0; row1 <= FIELD_ROWS - 1; row1++) {
		for(col1 = 0; col1 <= FIELD_COLS - 1; col1++) {
			cell1 = &side->field[row1][col1];
			if(!cell1->root/*T*/) {
				continue;
			}

			/* ɂA܂́A͂ɂ̏łZbgAbv܂B */
			cell1->stat = CELL_STAT_ERASE;
			cell1->cnt = -ERASE_INTERVAL * cell1->depth;

			/* ɂȂ... */
			if(cell1->type == CELL_TYPE_NYAN) {

				/* +1܂B
				 * - ͂ɂ́A̘AȂɋL\܂B
				 *   ̏ꍇA͂ɂrootɂ́Aꂩ̒T_i[Ă܂B
				 *   ͂ɂroot́APȂ}[NłAǂ̘AȂɑ邩𔻒fł܂B
				 *   ]Ăł͒ʏ̂ɂ݂̂JEgAƂŒT_Ƃɖ+1܂B
				 */
				root_length[cell1->root]++;

				/* XRAZ܂B
				 * - {͂ɂЂƂ100_łAP/ECE͌̓s10_Ƃ܂B
				 * - ͂ɂ₨܂ĂA_͂܂B({)
				 */
				score_add(side, 10);

				/* ɂAA[_Ȃ... */
				if(!cell1->inner) {

					/* +1܂B */
					root_branch[cell1->root]++;

					/* bU͂ƂāA[_̐[xv܂B
					 * - [głԁA[x1̒[_ɂ́AU͂܂B
					 *   [gオA[x1̒[_ɂAU͂܂B
					 */
					if(game.rate || (cell1->depth >= 2)) {
						root_attack[cell1->root] += cell1->depth;

						/* UGtFNg\񂵂܂B */
						fire_gen1(side, col1, row1, cell1->cnt);
					}
				}
			}

			/* ɂA܂́A͂ɂ̏łɗאڂ邨܂AłZbgAbv܂B */
			for(dir = 0; dir < 4; dir++) {
				col2 = col1 + erase_dir_tbl[dir][0];
				row2 = row1 + erase_dir_tbl[dir][1];
				if((col2 < 0) || (col2 > FIELD_COLS - 1) ||
				   (row2 < 0) || (row2 > FIELD_ROWS - 1)) {
					continue;
				}
				cell2 = &side->field[row2][col2];
				if(cell2->type == CELL_TYPE_OJAMA) {
					if(cell2->stat != CELL_STAT_ERASE) { /* ̏ŃZbgAbv */
						cell2->stat = CELL_STAT_ERASE;
						cell2->cnt = cell1->cnt;
					} else if(cell2->cnt < cell1->cnt) { /* 葁ŋ@ɍXV */
						cell2->cnt = cell1->cnt;
					}
				}
			}
		}
	}

	/* ̏ł̍ő啪Ȁł̍ő咷AŜ̍U͂߂܂B */
	side->branch = 0;
	side->length = 0;
	for(root = 0; root < FIELD_COLS * FIELD_ROWS; root++) {
		if(!root_length[root] || !root_branch[root]) {
			continue;
		}

		/* ͂ɂ̕ƂāA+1܂B(̃RgQƂĂ) */
		root_length[root]++;

		/* ̏ł̍ő咷XV܂B */
		if(root_length[root] > side->length) {
			side->length = root_length[root];
		}

		/* ̏ł̍ő啪XV܂B */
		if(root_branch[root] > side->branch) {
			side->branch = root_branch[root];
		}

		/* U͂vZ܂B
		 * - U͌vZ̎́Aȉ̂ƂłB(ƂłɁA[g|܂)
		 *
		 *	ܐ = bU + (bU *  * 0.04)
		 *
		 *	Ql:	u|`bƂɂ`TCg Enjoy Pochinya`v	http://www2.ocn.ne.jp/~dricas/pochinya/
		 *		umṽy[W					http://www2.ocn.ne.jp/~dricas/pochinya/kihon/06.html
		 *
		 * - 0.04|͓̂̂ŁA1/16(=0.0625)őp邱Ƃɂ܂B
		 *   1/16(=0.0625)1/32(=0.03125)̂ǂɂ邩܂AU͍߂̕ʔƍlāAO҂Iт܂B
		 */
		attack += root_attack[root] + (root_attack[root] * root_branch[root] / 16);
	}

	/* [g|čU͂m肵ASide̍U͂Ɋi[܂B
	 * ̎_ł́A܂AU͂Ƃ܂̑Es܂B
	 */
	side->attack = attack *= (1 << game.rate);

	/* UGtFNg^Cvm肵܂B
	 * - ۂɂ́Aerase_done()ɂčU܂łɁA󋵂ς\܂B
	 *   UGtFNg^Cv͂܂ŖڈłAۂ̍UorEƂ͈قȂ\܂B
	 * - U܂͑E̔́Aerase_done()̏ƓłB
	 *   erase_done()̃RgQƂĂBf
	 */
	if(game.rate < 4/*4o߂őEȂ*/) {
		if(side->attack > side->ojama) {
			/* UGtFNg^Cv = U
			 * * ȉ̂悤ȃP[XłB
			 * - ƂƂ܂̂ŁAUׂ͂đɑ荞ޏꍇB
			 * - ܂𑊎EāAȂAU͂]A𑊎ɑ荞ޏꍇB
			 */
			type = FIRE_TYPE_KOUGEKI;
		} else {
			/* UGtFNg^Cv = E
			 * * ȉ̂悤ȃP[XłB
			 * - ܂𑊎EʁAU͂ȂȂꍇB
			 * - ƂƍU0ꍇB
			 *   ̏ꍇAUGtFNg͐ĂȂ͂Ȃ̂ŁǍfire_gen2()̓_~[ƂȂ܂B
			 */
			type = FIRE_TYPE_SOUSAI;
		}
	} else {
		/* UGtFNg^Cv = U
		 * * ȉ̂悤ȃP[XłB
		 * - [g㏸ɂ葊EȂA܂̗Lɂ炸U𑗂荞ޏꍇB
		 *   U0Ȃ΁AUGtFNg͐ĂȂ͂Ȃ̂ŁǍfire_gen2()̓_~[ƂȂ܂B
		 */
		type = FIRE_TYPE_KOUGEKI;
	}
	fire_gen2(side, type);
}

/****************************************************************************
 *	erase_action
 ****************************************************************************/

int
erase_action(SIDE* side)
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->type) {
				continue;
			}

			if(cell->stat == CELL_STAT_ERASE) {
				if(!cell->cnt) {
					side->quake_stat = QUAKE_STAT_ERASE;
					side->quake_cnt = 0;
				}
				if(cell->cnt < 2/*t[*/ * 5/*p^[*/ - 1) {
					cell->cnt++;
					active = 1; /* p */
				} else {
					memset(cell, 0, sizeof(CELL));
				}
			}
		}
	}

	return active;
}

/****************************************************************************
 *	erase_done
 ****************************************************************************/

/* Ŋ́AUAEȂǂs܂B
 * vl[`́AĂяoȂłB
 */
void
erase_done(SIDE* side)
{
	/* ő咷Aő啪XV܂B */
	if(side->branch > side->max_branch) {
		side->max_branch = side->branch;
	}
	if(side->length > side->max_length) {
		side->max_length = side->length;
	}

	/* U͂Ƃ܂𑊎E܂B
	 * - Xe[WJn4o߂AEȂ܂B
	 */
	if(game.rate < 4) {
		if(side->attack > side->ojama) {
			side->attack -= side->ojama;
			                side->ojama = 0;
		} else {
			side->ojama -= side->attack;
			               side->attack = 0;
		}
	}

	/* ɂ܂𑗂荞݂܂B */
	if(side->attack) {
		ojama_queue_gen(&game.side[side->i_side ^ 1], side->attack);
		side->attack = 0;
	}
}

/****************************************************************************
 *	ojama_init
 ****************************************************************************/

typedef struct _COL_H {
	unsigned char col;	/* CfNX */
	unsigned char h;	/* ςݏオ */
} COL_H;

static int
col_h_compare(const void* _a, const void* _b)
{
	const COL_H* a = _a;
	const COL_H* b = _b;

	/* I[o[t[͗L蓾Ȃ̂ŁAZŏ[łB */
	return a->h - b->h;
}

void
ojama_init(SIDE* side)
{
	COL_H col_h[FIELD_COLS];
	//
	int col;
	int row;
	CELL* cell;
	int i;
	int max_row;

	/* 񂲂Ƃ̂ܐNAĂ܂B */
	memset(side->ojama_num, 0, sizeof side->ojama_num);

	/* ܂΁AɋA܂B */
	if(!side->ojama) {
		return;
	}

	/* éAςݏオ𒲂ׂ܂B */
	/*{{nkZbgAbvp*/
	max_row = 0;
	/*}}nkZbgAbvp*/
	for(col = 0; col < FIELD_COLS; col++) {
		for(row = 0; row < FIELD_ROWS; row++) {
			cell = &side->field[row][col];
			if(cell->type) {
				break;
			}
		}
		col_h[col].col = col;
		col_h[col].h   = FIELD_ROWS - row;
		/*{{nkZbgAbvp*/
		if(row > max_row) {
			max_row = row;
		}
		/*}}nkZbgAbvp*/
	}

	/* Sɂ܂Ȃ΁AnkZbgAbv܂B */
	if(side->ojama >= FIELD_COLS) {
		side->quake_stat = QUAKE_STAT_OJAMA;
		side->quake_cnt = -max_row; /* Ŝ܂nAnkJn */
	}

	/* Ȃ΃_Ƃ邽߁A܂AVbt܂B */
	shuffle(col_h, FIELD_COLS, sizeof(COL_H), &seed);

	/* ςݏオ̒ႢɁAёւ܂B */
	qsort(col_h, FIELD_COLS, sizeof(COL_H), col_h_compare);

	/* ܂񂲂Ƃɕ܂B */
	i = 0;
	do {
		col = col_h[i].col;
		side->ojama_num[col]++;
		i = (i + 1) % FIELD_COLS;
	} while(--side->ojama);
}

/****************************************************************************
 *	ojama_action
 ****************************************************************************/

int
ojama_action(SIDE* side)
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;

	/* 񂲂Ƃ̂܂o܂B */
	row = 0; /* ܏os */
	for(col = 0; col < FIELD_COLS; col++) {
		cell = &side->field[row][col];
		if(cell->type) {
			continue;
		}

		if(side->ojama_num[col]) {
			side->ojama_num[col]--;
			//
			memset(cell, 0, sizeof(CELL));
			cell->type = CELL_TYPE_OJAMA;
			cell->stat = CELL_STAT_FALL;
			//cell->cnt = 0; 0ł
			//
			active = 1; /* p */
		}
	}

	/* ܂𗎉܂B */
	if(fall_action(side)) {
		active = 1; /* p */
	}

	/* ܒnɂnkĂA܂ő҂܂B
	 * - nḱAbg_disp()Ă΂quake_action()ɂĐis܂B
	 *   \sȂƁA܂łȂƂɒӂĂB
	 *   ojama_action()́Aʏ탋[v炵Ă΂Ȃ̂ŁA薳͂łB
	 *   Avl[`(\sȂ)Ăяo悤ȏꍇ́A
	 *   nk\番΍􂪕KvłB
	 */
	if(side->quake_stat == QUAKE_STAT_OJAMA) {
		active = 1; /* p */
	}

	return active;
}

/****************************************************************************
 *	hari_init
 ****************************************************************************/

void
hari_init(SIDE* side)
{
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(cell->type != CELL_TYPE_HARI) {
				continue; /* ͂ɂȊO */
			}

			/* ͂ɂ̉́Ao߃^[𐔂܂B
			 * ̉1JEgAv4^[o߂A܂ɕω܂B
			 * ωɁAƓAj[Vs߂ɁAԂƂ܂B
			 */
			cell->age++;
			if(cell->age >= 4) {
				memset(cell, 0, sizeof(CELL));
				cell->type = CELL_TYPE_OJAMA;
				cell->stat = CELL_STAT_FALL;
				//cell->cnt = 0; 0ł
			}
		}
	}
}

/****************************************************************************
 *	hari_action
 ****************************************************************************/

int
hari_action(SIDE* side)
{
	/* ͂ɂ񁨂ܕωɁAƓAj[Vs܂B */
	return fall_action(side);
}

/****************************************************************************
 *	think_init
 ****************************************************************************/

void
think_init(THINK* think, SIDE* side)
{
	/* ܂ANA܂B(think_value[]NA邽߂ɁAK{ł) */
	memset(think, 0, sizeof(THINK));

	/* Side𕡐܂B */
	think->side = *side;

	/* ȍ~A|C^sidéASide̕w܂B */
	side = &think->side;

	/* sp^[܂B
	 * - Side{kumi_hari,kumi_col,kumi_rot}A[vJE^˂Ă܂B
	 *   ̒lωAωlƁAAspSideփRs[܂B
	 * - kumi_roẃA݂ɂ̉eXgsʒuƂāÂ܂ܗp܂B
	 *   kumi_init()̖Ă΂̂ŁAkumi_row͏osƂȂĂ͂łB
	 */
	side->kumi_hari = 0;
	side->kumi_col = 0;
	//side->kumi_row = OUTER_ROWS/*Œ*/; ɂȂĂ͂
	side->kumi_rot = 0;
}

/****************************************************************************
 *	think_next
 ****************************************************************************/

void
think_next(THINK* think)
{
	static SIDE next; /* spSideBX^bNh~̂staticł!! */

	SIDE* side = &think->side;
	//
	int hari;
	int col;
	int row;
	int rot;
	CELL* cell;
	THINK_VALUE* value;

	/* ɊĂA܂B */
	if(think->done) {
		return;
	}

	/* sp^[ƏoʒůԂɏQ΁A]ΏۊOƂ܂B */
	col = side->kumi_col;
	row = side->kumi_row;
	for(;;) {
		cell = &side->field[row][col];
		if(cell->type) {
			goto L_SKIP; /* ړs */
		}
		       if(col < CENTER_COL) {
			col++;
		} else if(col > CENTER_COL) {
			col--;
		} else {
			break;
		}
	}

	/* ݂̎sp^[̉łȂ΁A]ΏۊOƂ܂B */
	if(!kumi_test(side,
		     side->kumi_col,
		     side->kumi_row,
		     side->kumi_rot)) {
		goto L_SKIP; /* ̉s */
	}

	/* sp^[̕]i[邽߂́A\̂̃|C^߂܂B */
	value = &think->value[side->kumi_hari]
			     [side->kumi_col ]
			     [side->kumi_rot ];

	/* spSideɌSideRs[A݂ɂ̉܂B */
	next = *side;
	kumi_done(&next);

	/* sʂ]܂B */
	think_eval(think, &next, value);

L_SKIP:

	/* sp^[֐i߂܂B */
	if(side->kumi_hari < 2 - 1) {
		side->kumi_hari++;
		return; /* p */
	} else {
		side->kumi_hari = 0;
		if(side->kumi_col < FIELD_COLS - 1) {
			side->kumi_col++;
			return; /* p */
		} else {
			side->kumi_col = 0;
			if(side->kumi_rot < 4 - 1) {
				side->kumi_rot++;
				return; /* p */
			} else {
				side->kumi_rot = 0;
			}
		}
	}

	/* őP̎sp^[肵܂B
	 * - SĂ̎sp^[]ΏۊOꍇ̂߂ɁAlݒ肵Ă܂B
	 *   ʒuƉ]͏oԂƓA~̖]݂Ă͂ɂ񉻂邱Ƃɂ܂B
	 */
	think->hari = 1;
	think->col  = CENTER_COL;
	think->rot  = KUMI_ROT_UP;
	for(hari = 0; hari < 2; hari++) {
		for(col = 0; col < FIELD_COLS; col++) {
			for(rot = 0; rot < 4; rot++) {
				if(think_compare(think,
					&think->value[       hari][       col][       rot],
					&think->value[think->hari][think->col][think->rot]) > 0) {
						think->hari = hari;
						think->col  = col;
						think->rot  = rot;
				}
			}
		}
	}

	think->done = 1; /*  */
}

/****************************************************************************
 *	think_eval
 ****************************************************************************/

void
think_eval(THINK* think, SIDE* side, THINK_VALUE* value)
{
	int space_weight_all = 0; /* SZ̏dݑv */
	int space_weight_sum = 0; /* 󂫃Z̏dݍv */
	int space_weight;         /* ݂̃Z̏d   */
	//
	int col1;
	int row1;
	CELL* cell1;
	int col2;
	int row2;
	CELL* cell2;
	int vcol;
	int vrow;
	int i_form;

	/* AŏsAU͂]܂B */
	for(;;) {
		while(fall_action(side)) {
			/** no job **/
		}
		if(!erase_test(side)) {
			break;
		}
		erase_init(side);
		while(erase_action(side)) { /* fire_action()͕svł */
			/** no job **/
		}
		value->attack += side->attack; /* A͍U͂Z */
	}

	/* U0̖ʂȂ͂ɂ́A]ΏۊOƂ܂B */
	if(!value->attack && side->kumi_hari) {
		return;
	}

	/* tB[h̐ÓI]s܂B */
	for(row1 = 0; row1 <= FIELD_ROWS - 1; row1++) {
		for(col1 = 0; col1 <= FIELD_COLS - 1; col1++) {
			space_weight = space_weight_tbl[row1][col1];	/* ݂̃Z̏d   */
			if(space_weight) {
				space_weight += SPACE_WEIGHT_BIAS;
			}
			space_weight_all += space_weight;		/* SZ̏dݑv */
			cell1 = &side->field[row1][col1];
			if(!cell1->type) {
				space_weight_sum += space_weight;	/* 󂫃Z̏dݍv */
				continue;
			}

			switch(cell1->type) {
			case CELL_TYPE_OJAMA:
				value->ojama++;
				break;

			case CELL_TYPE_NYAN:
				/* 3x3̓Fуp^[ɂAɂzu]܂B */
				i_form = 0;
				for(vrow = -1; vrow <= 1; vrow++) {
					for(vcol = -1; vcol <= 1; vcol++) {
						if(!vcol && !vrow) {
							continue; /* 3x3̒͊܂߂Ȃ */
						}
						i_form <<= 1;
						//
						col2 = col1 + vcol;
						row2 = row1 + vrow;
						if((col2 < 0) || (col2 > FIELD_COLS - 1) ||
						   (row2 < 0) || (row2 > FIELD_ROWS - 1)) {
							continue;
						}
						//
						cell2 = &side->field[row2][col2];
						if(cell2->color == cell1->color) {
							i_form |= 1;
						}
					}
				}
				value->form += form_tbl[i_form];
				break;
			}
		}
	}

	/* ʓ̋󂫃ZwW߂܂B */
	value->space = fidiv(fild(space_weight_sum), space_weight_all);

	value->valid = 1; /* ]Ώ */
}

/****************************************************************************
 *	think_compare
 ****************************************************************************/

int
think_compare(THINK* think, const THINK_VALUE* v1, const THINK_VALUE* v2)
{
	const LEVEL* level = &level_tbl[think->side.i_ch];
	//
	fixed d1;
	fixed d2;

	/* ]ΏہA]ΏۊȎgr܂B */
	if(v1->valid) {
		if(v2->valid) {
			/* v1Av2Ƃ]ΏہBڍהr */
		} else {
			return  1; /* v1̂ݕ]Ώ */
		}
	} else {
		if(v2->valid) {
			return -1; /* v2̂ݕ]Ώ */
		} else {
			return 0; /* v1Av2Ƃ]ΏۊO */
		}
	}

	/* U͂r܂B */
	if(fcom(fild(v1->attack), >=, fimul(v1->space, level->space_rate))) {
		if(v1->attack > v2->attack) {
			return 1;
		}
	}
	if(fcom(fild(v2->attack), >=, fimul(v2->space, level->space_rate))) {
		if(v2->attack > v1->attack) {
			return -1;
		}
	}

	/* ɂzuƉʓ̋󂫃ZwWA|킹Ĕr܂B
	 * - ɂzu̕]0Ȃ΁A󂫃ZwWŔr܂B
	 *   ͂ɂzu0ƕ]̂ŁÂ߂̑΍łB
	 */
	d1 = v1->form ? fimul(v1->space, v1->form) : v1->space;
	d2 = v2->form ? fimul(v2->space, v2->form) : v2->space;
	if(fcom(d1, >, d2)) {
		return 1;
	}
	if(fcom(d2, >, d1)) {
		return -1;
	}

	/* v:ǂ̕]ɂׂȁH */

	/* ܐr܂B */
	if(v1->ojama < v2->ojama) {
		return 1;
	}
	if(v2->ojama < v1->ojama) {
		return -1;
	}

	return 0;
}

/****************************************************************************
 *	fire_gen2
 ****************************************************************************/

void
fire_gen1(SIDE* side, int col, int row, int cnt)
{
	int i;
	FIRE* fire;

	/* UGtFNg̃Gg\񂵂܂B */
	for(i = 0; i < MAX_FIRE; i++) {
		fire = &side->fire[i];
		if(fire->type) {
			continue; /* gp */
		}

		memset(fire, 0, sizeof(FIRE));
		fire->type = FIRE_TYPE_YOYAKU; /* \ (fire_gen2()ɂčUorEɕύX) */
		fire->cnt = cnt;
		fire->col = col;
		fire->row = row;
		return; /* ܂ */
	}
}

/****************************************************************************
 *	fire_gen2
 ****************************************************************************/

void
fire_gen2(SIDE* side, int type)
{
	int i;
	FIRE* fire;

	/* \񂵂UGtFNg̃^Cvm肵܂B */
	for(i = 0; i < MAX_FIRE; i++) {
		fire = &side->fire[i];
		if(fire->type == FIRE_TYPE_YOYAKU) {
			fire->type = type;
		}
	}
}

/****************************************************************************
 *	fire_action
 ****************************************************************************/

#define FIRE_TIME_1	SEC(0.50)	/* UGtFNgړ   () */
#define FIRE_TIME_2	SEC(0.25)	/* UGtFNgړ㎞ () */

int
fire_action(SIDE* side)
{
	int active = 0;
	//
	int i;
	FIRE* fire;

	for(i = 0; i < MAX_FIRE; i++) {
		fire = &side->fire[i];
		if(!fire->type) {
			continue; /* gp */
		}

		switch(fire->stat) {
		case 0:
			if(fire->cnt < 2 * 6 - 1) {
				fire->cnt++;
			} else {
				fire->stat++;
				fire->cnt = 0;
			}
			break;
		case 1:
			if(fire->cnt < FIRE_TIME_1 - 1) {
				fire->cnt++;
			} else {
				fire->stat++;
				fire->cnt = 0;
			}
			break;
		case 2:
			if(fire->cnt < FIRE_TIME_2 - 1) {
				fire->cnt++;
			} else {
				memset(fire, 0, sizeof(FIRE));
			}
			break;
		default:
			DIE();
		}

		if(fire->type) {
			active = 1; /* p */
		}
	}

	return active;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
fire_disp(int i_side)
{
	SIDE* side = &game.side[i_side];
	const PTN* ptn = &ptn_tbl[i_side];
	//
	int i;
	int x;
	int y;
	int x1;
	int y1;
	int x2;
	int y2;
	int sprno;
	FIRE* fire;
	fixed d;

	for(i = 0; i < MAX_FIRE; i++) {
		fire = &side->fire[i];
		if(!fire->type) {
			continue; /* gp */
		}
		if(fire->cnt < 0) {
			continue; /* oO */
		}

		x1 = side->disp_field_x + CELL_W * fire->col;
		y1 = side->disp_field_y + CELL_H * fire->row;

		switch(fire->type) {
		case FIRE_TYPE_KOUGEKI:
			x2 = game.side[side->i_side ^ 1].disp_field_x;
			y2 = game.side[side->i_side ^ 1].disp_field_y;
			break;
		case FIRE_TYPE_SOUSAI:
			x2 = side->disp_field_x;
			y2 = side->disp_field_y;
			break;
		default:
			DIE();
		}
		x2 += CELL_W * CENTER_COL;
		y2 += CELL_H * OUTER_ROWS;

		switch(fire->stat) {
		case 0:
			sprno = fire->cnt / 2;
			if(sprno >= 6) {
				DIE();
			}
			x = x1;
			y = y1;
			break;
		case 1:
			sprno = 6 + (fire->cnt & 3);
			d = fidiv(fimul(PI_2, fire->cnt), FIRE_TIME_1);	/* 0/2 */
			d = fcos(d);					/* 10 () */
			x = fist(fiadd(fimul(d, x1 - x2), x2));		/* x = x2 + (x1 - x2) * d */
			y = fist(fiadd(fimul(d, y1 - y2), y2));		/* y = y2 + (y1 - y2) * d */
			break;
		case 2:
			sprno = 6 + (fire->cnt & 3);
			x = x2 + RND16_RANGE(seed, -CELL_W, CELL_W + 1);
			y = y2 + RND16_RANGE(seed, -CELL_H, CELL_H + 1);
			break;
		default:
			DIE();
		}

		sprno = ptn->fire[sprno];
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}
}

/****************************************************************************
 *	ojama_queue_gen
 ****************************************************************************/

void
ojama_queue_gen(SIDE* side, int ojama)
{
	int i;
	OJAMA_QUEUE* queue;

	for(i = 0; i < MAX_OJAMA_QUEUE; i++) {
		queue = &side->ojama_queue[i];
		if(queue->ojama) {
			continue; /* gp */
		}

		memset(queue, 0, sizeof(OJAMA_QUEUE));
		queue->delay = ((2 * 6) - (2 * 5))	/* UGtFNgoƁAɂ̏ł́AAj[VԂ̒̍ */
			     + FIRE_TIME_1		/* UGtFNgړ */
			     + FIRE_TIME_2;		/* UGtFNgړ㎞ */
		queue->ojama = ojama;
		return; /* ܂ */
	}

	DIE(); /* ܃L[̃GgsA܂́AxԂA܂́Aojama_queue_action()ĂіY */
}

/****************************************************************************
 *	ojama_queue_action
 ****************************************************************************/

void
ojama_queue_action(SIDE* side)
{
	int i;
	OJAMA_QUEUE* queue;

	for(i = 0; i < MAX_OJAMA_QUEUE; i++) {
		queue = &side->ojama_queue[i];
		if(!queue->ojama) {
			continue; /* 󂫃Gg */
		}

		if(!--queue->delay) {
			side->ojama += queue->ojama;
			memset(queue, 0, sizeof(OJAMA_QUEUE));
		}
	}
}

